@echo off
rem Written for http://www.sb-innovation.de/showthread.php?p=335167
SetLocal EnableDelayedExpansion
cd /d %~dp0
color 0e

set timeout=3600
rem TODO: update the title whenever %ip2%, %times% or %timeout% change
rem e.g. "IP Check [ Last: %ip2% ] [ %times% runs, delay: %timeout%s ] [ Session: %sid% ]"
title Check your IP every %timeout% seconds
set logfile=ips.txt
set ip1=0.0.0.0
set ip2=0.0.0.0
set times=0
set ipchecksite=http://ipcheck1.jdownloader.org/
set sidlength=10
set charset=abcdefghijklmnopqrstuvwxyz0123456789
:genchar
set /a index=%random%*36/32767
set sid=%sid%!charset:~%index%,1!
set /a sidlength-=1
if %sidlength% gtr 0 goto genchar

if exist %logfile% (
	echo * Log file "%logfile%" found, starting session %sid%...
	echo ======================================================================== >> %logfile%
	echo [%date% %time%] Started a new session >> %logfile%
) else (
	echo * Log file "%logfile%" not found, creating and starting session %sid%...
	echo ======================================================================== > %logfile%
	echo [%date% %time%] Creating log file "%logfile%" >> %logfile%
)
echo [%date% %time%] Session ID for this run is: %sid% >> %logfile%

:loop
rem TODO: the following counter won't be accurate after 2147483647 checks
set /a times=%times%+1
echo.
echo * Grabbing external IP (round no. %times%)...
echo.
for /f "usebackq" %%x in (`wget "%ipchecksite%" -U "" -q -O -`) do set ip2=%%x

rem TODO: if anyone wants to extend this, here would be a good place to check
rem wget's success or failure and act accordingly
rem Currently, there is no error checking and wget's input is not sanitized

if "%ip1%"=="0.0.0.0" (
	echo * Got the first IP for the session, it is: %ip2%
	echo [%date% %time%] Initial IP: %ip2% >> %logfile%
	set ip1=%ip2%
	goto wait
)

if not "%ip1%"=="%ip2%" (
	echo * IP changed from %ip1% to %ip2%
	rem TODO: perhaps ring the bell (echo ^G) or play a sound here
	echo [%date% %time%] *** IP CHANGE DETECTED *** %ip1% -^> %ip2% >> %logfile%
	set ip1=%ip2%
) else (
	echo * IP is still the same [ %ip2% ]
	echo [%date% %time%] IP is still %ip2% >> %logfile%
)
:wait
echo.
echo * Will now wait %timeout% seconds... (Press Ctrl+C then N for more.)
timeout /t %timeout% /nobreak && goto loop
:quitprompt
echo.
choice /c re /n /m "Do you want to [r]esume checking or [e]xit? [re]"
echo.
if %errorlevel%==1 goto loop
if %errorlevel%==2 goto end
echo Invalid choice, press a key and try again.
pause > nul
goto quitprompt

:end
echo * Exiting...
echo [%date% %time%] Session %sid% terminated manually, exiting... >> %logfile%
echo ======================================================================== >> %logfile%
echo. >> %logfile%
exit
